/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.utilities.Clipboard;

import java.util.Map;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.utilities.Clipboard.ClipboardShared.*;

/**
 * @author Krzysztof Nowinski (know)
 * Warsaw University, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 */
public class GUI extends javax.swing.JPanel
{

    private Map clipboard;
    private Parameters parameters;
    private boolean active = true;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        if (clipboard != null) {
            Object[] keys = clipboard.keySet().toArray();
            String[] names = new String[keys.length];
            for (int i = 0; i < names.length; i++)
                names[i] = (String) keys[i] + ":   " + clipboard.get(keys[i]);
            contentList.setListData(names);
            String selectedFieldName = p.get(SELECTED_FIELD_NAME);
            boolean createGeometries = p.get(CREATE_GEOMETRIES);
            contentList.setSelectedValue(selectedFieldName, true);
            if (createGeometries) {
                geomCheckBox.setSelected(true);
            } else {
                geomCheckBox.setSelected(false);
            }
        }
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        contentList = new javax.swing.JList<>();
        removeButton = new javax.swing.JButton();
        clearButton = new javax.swing.JButton();
        geomCheckBox = new javax.swing.JCheckBox();

        setMinimumSize(new java.awt.Dimension(184, 155));
        setPreferredSize(new java.awt.Dimension(224, 241));
        setLayout(new java.awt.GridBagLayout());

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        jScrollPane1.setMinimumSize(new java.awt.Dimension(200, 300));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(259, 500));

        contentList.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        contentList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                contentListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(contentList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(jScrollPane1, gridBagConstraints);

        removeButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        removeButton.setText("remove");
        removeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                removeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(removeButton, gridBagConstraints);

        clearButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        clearButton.setText("clear all");
        clearButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(clearButton, gridBagConstraints);

        geomCheckBox.setSelected(true);
        geomCheckBox.setText("  create geometries");
        geomCheckBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                geomCheckBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(geomCheckBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void contentListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_contentListValueChanged
    {//GEN-HEADEREND:event_contentListValueChanged
        if (active) {
            String value = contentList.getSelectedValue();
            if(value != null && !value.isEmpty()) {
                parameters.set(SELECTED_FIELD_NAME, value.split(":")[0]);
            }
        }
    }//GEN-LAST:event_contentListValueChanged

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_removeButtonActionPerformed
    {//GEN-HEADEREND:event_removeButtonActionPerformed
        parameters.set(REMOVE, true);
    }//GEN-LAST:event_removeButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_clearButtonActionPerformed
    {//GEN-HEADEREND:event_clearButtonActionPerformed
        parameters.set(CLEAR, true);
    }//GEN-LAST:event_clearButtonActionPerformed

    private void geomCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_geomCheckBoxActionPerformed
    {//GEN-HEADEREND:event_geomCheckBoxActionPerformed
        parameters.set(CREATE_GEOMETRIES, geomCheckBox.isSelected());
    }//GEN-LAST:event_geomCheckBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton clearButton;
    private javax.swing.JList<String> contentList;
    private javax.swing.JCheckBox geomCheckBox;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton removeButton;
    // End of variables declaration//GEN-END:variables

    public void setClipboard(Map clipboard)
    {
        this.clipboard = clipboard;
        updateList();
    }

    public void updateList()
    {
        active = false;
        Object[] keys = clipboard.keySet().toArray();
        String[] names = new String[keys.length];
        for (int i = 0; i < names.length; i++)
            names[i] = (String) keys[i] + ":   " + clipboard.get(keys[i]);
        contentList.setListData(names);
        contentList.clearSelection();
        parameters.set(SELECTED_FIELD_NAME, "");
        active = true;
    }
}
